const m = (n, t, e, ...r) => {
  const i = `[${n.get("$environment").name || "webprovisions"}] ${e}`;
  switch (t) {
    case "info":
      console.info(i, ...r);
      break;
    case "warning":
      console.warn(i, ...r);
      break;
    case "error":
      console.error(i, ...r);
      break;
  }
}, E = (n) => {
  const t = n.container || n;
  return {
    info: (e, ...r) => m(t, "info", e, ...r),
    warn: (e, ...r) => m(t, "warning", e, ...r),
    error: (e, ...r) => m(t, "error", e, ...r)
  };
}, b = (n, t) => {
  if (!t)
    return !0;
  if (typeof t == "string") {
    const e = t.split(",");
    for (let r = 0, i = e.length; r < i; r++) {
      const o = e[r].trim();
      if (o === n || o === "*")
        return !0;
    }
  }
  return t instanceof Array ? t.indexOf(n) > -1 : !1;
}, x = (n, t) => {
  if (typeof t == "function")
    return t(n);
  const e = typeof t == "string" ? q(t) : t;
  return !(!b(n.tenant || "", e.tenant) || !b(n.name, e.implementation));
}, I = (n) => (t) => x(t, n), f = (n) => n instanceof Array && n.length === 1 ? n[0] : n, q = (n) => {
  const t = {}, e = n.split(":");
  return e.length === 1 ? t.implementation = f(e[0].split(",")) : (t.tenant = f(e[0].split(",")), t.implementation = f(e[1].split(","))), t;
};
var p = /* @__PURE__ */ ((n) => (n.Implementation = "implementation", n.Widget = "widget", n))(p || {}), u = /* @__PURE__ */ ((n) => (n.Pre = "pre", n.Post = "post", n))(u || {});
const L = (n, t, e, r) => {
  try {
    const i = new t(e, r);
    return {
      name: n,
      invoke: (o, s) => {
        let a;
        return i[o] && (a = i[o].call(i, s)), Promise.resolve(a);
      },
      getInstance: () => i
    };
  } catch (i) {
    if (i.message && i.message.indexOf("is not a constructor") >= 0)
      return {
        name: n,
        invoke: (o) => {
          let s;
          return o === "initialize" && (s = t(e, r)), Promise.resolve(s);
        },
        getInstance: () => t
      };
    throw i;
  }
};
function y(n, t) {
  return typeof n == "undefined" ? t : n;
}
class O {
  constructor(t = {}) {
    this.part = t;
  }
  createCommand(t, e, r) {
    let i;
    typeof e == "function" ? i = {
      scope: p.Widget,
      stage: u.Post,
      defaultArgs: void 0,
      handlerResolver: e
    } : i = {
      scope: y(e.scope, p.Widget),
      stage: y(e.stage, u.Post),
      defaultArgs: e.defaultArgs,
      handlerResolver: r
    };
    let o = this.part;
    const s = t.split(".");
    return s.forEach((a, c) => {
      c === s.length - 1 ? o[a] || (o[a] = () => i) : o = this.part[a] = this.part[a] || {};
    }), this;
  }
  get() {
    return this.part;
  }
}
const A = (n) => {
  const t = new O({});
  return n(t), t.get();
};
A((n) => {
  n.createCommand(
    "types.register",
    { scope: p.Implementation, stage: u.Pre },
    (t) => (e, r) => {
      t.container.get("$types")[e] = r;
    }
  ).createCommand(
    "type",
    { stage: u.Pre },
    (t) => (e) => {
      t.container.register("$type", e);
    }
  ).createCommand(
    "csp",
    {},
    (t) => (e) => {
      console.log("Registering csp"), t.container.register("csp", e);
    }
  ).createCommand(
    "settings",
    { stage: u.Pre, defaultArgs: [null] },
    (t) => (e) => {
      t.events.dispatch(
        "settings:change",
        e,
        { bubbles: !0 }
      ), t.container.register("$settings", e);
    }
  ).createCommand(
    "plugin",
    { stage: u.Pre },
    (t) => (e, r, i) => {
      const { container: o } = t;
      let s = null, a = e, c = r;
      typeof e == "string" && (s = e, a = r, c = i);
      const l = (g) => {
        const { transformPluginSettings: h } = t.container.get("$environmentOptions"), k = h ? h(
          c || {},
          s,
          t.container,
          a
        ) : r;
        try {
          const d = L(
            s,
            a,
            o,
            k
          );
          o.get("$plugins").push(d), g && d.invoke("initialize", null);
        } catch (d) {
          E(t).warn("Error when initializing plugin", d);
        }
      };
      t.container.get("$instance") ? l(!0) : t.events.subscribeOnce("widget:instance-created", () => l(!1));
    }
  ).createCommand(
    "container.register",
    (t) => (e, r) => {
      t.container.register(e, r);
    }
  ).createCommand(
    "container.registerAsync",
    (t) => (e, r) => {
      t.container.registerAsync(e, r);
    }
  ).createCommand(
    "container.registerFactory",
    (t) => (e, r) => {
      t.container.registerFactory(e, r);
    }
  ).createCommand(
    "container.touch",
    (t) => (e, r) => {
      t.container.touch(e, r);
    }
  );
});
function R(n, t, e) {
  return Array.from(n.querySelectorAll(
    `div[id^="${t}_"], div[id^="${t}:"]`
  )).map((r) => {
    if (r.id.substr(0, 7) === `${t}_`)
      return { widgetName: r.id.substr(7), element: r };
    const { 3: i } = r.id.split(":");
    return { widgetName: i, element: r };
  });
}
const S = (n) => {
  const t = n.map((e) => e.replace(/\./g, "\\.")).join("|");
  return new RegExp("^((http[s]?:)?//)?(" + t + ")/([^\\s]+)");
}, W = (n) => n.href;
function M(n, t) {
  const e = S(t), r = (i) => {
    const o = e.exec(W(i));
    return o ? {
      element: i,
      widget: o[4]
    } : null;
  };
  return Array.from(n.querySelectorAll("a")).map((i) => r(i)).filter((i) => !!i).reduce((i, o) => (o && i.push({
    element: o.element,
    widgetName: o.widget
  }), i), []);
}
function P(n) {
  return n.filter((t, e, r) => r.indexOf(t) === e);
}
class z {
  constructor(t) {
    this.container = t.container, this.events = t.events;
  }
  watch(t) {
    const e = this.container.get("triggerElements") || [], r = P(e.concat(t));
    this.container.register("triggerElements", r), this.events.dispatch(
      "bootstrap:trigger-elements-updated",
      { triggerElements: r },
      { bubbles: !0 }
    );
  }
}
function C(n, ...t) {
  return n.implementation.events.subscribe("widget:create-instance", (e, r) => {
    if (e.target === n) {
      let i = n.container.get("bootstrapping.monitor");
      i || (i = new z(n), n.container.register("bootstrapping.monitor", i)), i.watch(t);
    }
  }), n.load();
}
function $(n, t = document) {
  const e = n.bindings, r = [].concat(
    M(t, e),
    R(t, n.environment.name || "")
  ), i = P(r.map(({ widgetName: o }) => o));
  return Promise.all(i.reduce((o, s) => {
    const a = n.widgets.get(s);
    if (!a)
      return process.env.NODE_ENV !== "production" && E(n).warn(`A trigger element for "${s}" was found but no widget with that name is available on the implementation ("${n.name}"). Make sure this is not a mistake.`), Promise.resolve();
    const c = r.filter((g) => g.widgetName === s).map((g) => g.element), l = C(a, ...c);
    return o.push(l), o;
  }, []));
}
function D() {
  return new Promise((n) => {
    document.readyState === "loading" ? document.addEventListener("DOMContentLoaded", () => n(void 0)) : n(void 0);
  });
}
const N = (n, t) => {
  const e = n;
  e.scan = (i) => $(e, i), e.bindings = t, e.attach = (i, ...o) => C(i, ...o);
  const { environment: r } = e;
  return typeof r.configure == "undefined" && (r.configure = (i, o) => {
    let s, a;
    o ? (s = i, a = o) : (s = "*", a = i), r.implementations.query(s).forEach((c) => c.configure(a)), r.events.subscribe("implementation:created", (c, l) => {
      const { implementation: g } = l;
      I(s)(g) && g.configure(a);
    });
  }), e;
};
function B(n, t, e = () => [], r) {
  const i = { ready: !1 };
  n.container.register("bootstrapping", i);
  const o = N(n, t);
  return D().then(() => {
    n.configure((...s) => {
      e().forEach((a) => a(...s));
    });
  }).then(() => $(o, r())).then(() => (i.ready = !0, n.events.dispatch("bootstrap:ready", {}), o));
}
function _(n) {
  const t = {};
  return [].filter.call(n.attributes, (e) => /^data-/.test(e.name)).map((e) => e.name).forEach((e) => t[e.substr(5)] = n.getAttribute(e)), t;
}
const v = (n, t, e) => {
  const r = _(n);
  e({
    sourceDOMElement: n,
    eventType: t,
    data: r
  });
};
function w(n, t, e) {
  n.forEach((r) => {
    r.dataset.attached !== "true" && (t === "load" ? v(r, t, e) : r.addEventListener(t, (i) => {
      i.preventDefault(), v(r, t, e);
    }), r.dataset.monitored = "true");
  });
}
function U(n, t, e) {
  const r = n.container.get("bootstrapping.monitor");
  r && r.events.subscribe("bootstrap:trigger-elements-updated", (o, s) => {
    w(
      s.triggerElements,
      t,
      e
    );
  });
  const i = n.container.get("triggerElements");
  i && w(
    i,
    t,
    e
  );
}
const j = (n, t, e) => {
  const r = n.split(":"), i = r[0], o = r.length > 1 ? r[1] : "*";
  return (t === "*" || i === t) && (e === "*" || o === e);
};
function V(n, t = "*", e = "*") {
  return n.filter((r) => {
    const i = r[0], o = r[1];
    return typeof i == "string" && typeof o == "function" ? j(i, t, e) : !1;
  }).map((r) => r[1]);
}
const F = A((n) => {
  n.createCommand(
    "ready",
    { scope: p.Implementation, stage: u.Pre },
    (t) => (e) => {
      const { container: r } = t, i = r.owner;
      r.get("bootstrapping").ready ? e(i) : i.events.subscribeOnce("bootstrap:ready", () => {
        e(i);
      });
    }
  );
});
export {
  F as ConfigurationApi,
  B as bootstrapImplementation,
  V as parseConfigurationHandlers,
  U as supportBootstrapping
};
//# sourceMappingURL=index.js.map
